=== demo/Elements/cpp/Makefile ===

FLAGS=--integration-method=symbolic --debug=0
#FLAGS=--integration-method=quadrature

FORM=Elements

demo: main.cpp generated_code/$(FORM).h
	scons -j3

generated_code/$(FORM).h: $(FORM).ufl
	sfc -w1 $(FLAGS) -ogenerated_code $(FORM).ufl

bench: $(FORM).ufl
	sfc -b1 $(FLAGS) $(FORM).ufl

view: run
	paraview --data=s2_2D.pvd &

run: demo
	rm -f *.pvd *.vtu
	./demo

debug: demo
	gdb ./demo

clean:
	rm -f *.pvd *.vtu
	rm -rf demo generated_code *.o 
	rm -f *.pyc
