=== demo/HyperElasticity1D/cpp/Makefile ===

FLAGS=--integration-method=quadrature --integration-order=9 --safemode=0

FORM=HyperElasticity1D

demo: main.cpp generated_code/$(FORM).h
	scons -j3

generated_code/$(FORM).h: $(FORM).ufl
	sfc -w1 $(FLAGS) -ogenerated_code $(FORM).ufl

generate: clean demo

bench: $(FORM).ufl
	sfc -b1 $(FLAGS) $(FORM).ufl

view: run
	paraview --data=u.pvd &
	#paraview --data=usol.pvd &
	paraview --data=e.pvd &

run: demo
	rm -f *.pvd *.vtu
	./demo

debug: demo
	gdb ./demo

clean:
	rm -f *.pvd *.vtu
	rm -rf demo generated_code *.o 
	rm -f *.pyc
