=== demo/Poisson2D/cpp/Makefile ===

FLAGS=--integration-method=symbolic
#FLAGS=--integration-method=quadrature --integration-order=15

FORM=Poisson

demo: main.cpp generated_code/$(FORM).h
	scons -j3

generated_code/$(FORM).h: $(FORM).ufl
	sfc -w1 $(FLAGS) -ogenerated_code $(FORM).ufl

generate: clean demo

bench: $(FORM).ufl
	sfc -b1 $(FLAGS) $(FORM).ufl

view: run
	paraview --data=u.pvd &

run: demo
	rm -f *.pvd *.vtu
	./demo

debug: demo
	gdb ./demo

clean:
	rm -f *.pvd *.vtu
	rm -rf demo generated_code *.o 
	rm -f *.pyc
