## syfi 0.6.2.dfsg

=== SConstruct ===
--- 
+++ 
@@ -24,7 +24,7 @@
 env["projectname"] = "syfi"
 
 # Set version
-env["SYFILIB_VERSION"] = "0.6.1"
+env["SYFILIB_VERSION"] = "0.6.2"
 
 def replace_lines(dotin_fname, replacements):
     f = file(dotin_fname)
