## syfi 1.0-beta.dfsg

=== debian/changelog ===
syfi (1.0-beta.dfsg-2) unstable; urgency=low

  * Update short description for all packages (closes: #643600).
  * Add patch to fix "FTBFS against libginac2: error: =format-security:
    No such file or directory" (closes: #644044).

 -- Johannes Ring <johannr@simula.no>  Sun, 02 Oct 2011 18:14:26 +0200

syfi (1.0-beta.dfsg-1) unstable; urgency=low

  * New upstream release. This release adds support for GiNaC 1.6
    (closes: #628243).
  * Update Homepage field in debian/control and Maintainer field in
    debian/copyright.
  * Bump Standards-Version to 3.9.2 (no changes needed).
  * Move from python-central to dh_python2 (closes: #617116).
    - Remove python-central from Build-Depends.
    - Bump minimum required python-all-dev package version to 2.6.6-3~.
    - Remove XB-Python-Version line.
    - Bump minimum required cdbs version to 0.4.90~.
    - Replace XS-Python-Version with X-Python-Version.
    - Replace call to dh_pycentral with dh_python2 in debian/rules.
  * Build for all supported Python versions.
  * Rename binary package syfi-bin to sfc.
  * Rename binary package python-syfi0 to python-syfi.
  * Switch from SCons to CMake:
    - Replace scons with cmake in Build-Depends in debian/control.
    - Remove custom cdbs class for SCons.
    - Update debian/rules to build with CMake.
  * Switch to dpkg-source 3.0 (quilt) format.
  * Update for new SOVERSION:
    - Rename debian/libsyfi0.install to debian/libsyfi1.0.install and
      debian/libsyfi0-dev.install to debian/libsyfi1.0-dev.install.
    - Replace libsyfi0 with libsyfi1.0 and libsyfi0-dev with
      libsyfi1.0-dev in debian/control. Update Conflicts, Replaces, and
      Provides as necessary.
  * Add lintian override syfi-dev: empty-binary-package.
  * Add patch for removing unnecessary include directories from
    pkgconfig file (syfi.pc) and CMake config file (syfi-config.cmake).
  * Use DEB_COMPRESS_EXCLUDE_ALL instead of deprecated
    DEB_COMPRESS_EXCLUDE in debian/rules.
  * Remove custom cdbs rules and licensecheck script for copyright check.
  * Update debian/copyright and debian/copyright_hints.

 -- Johannes Ring <johannr@simula.no>  Tue, 06 Sep 2011 14:41:46 +0200

syfi (0.6.2.dfsg-1) unstable; urgency=low

  * New upstream release (Closes: #585360).
  * Package moved from pkg-scicomp to Debian Science.
  * Allow both .tgz and .tar.gz extensions in debian/watch.
  * Minor update in debian/copyright and debian/copyright_hints.

 -- Johannes Ring <johannr@simula.no>  Mon, 09 Aug 2010 16:10:50 +0200

syfi (0.6.1.dfsg-1) unstable; urgency=low

  * New upstream release.
  * debian/control:
    - Add DM-Upload-Allowed: yes.
    - Bump Standards-Version to 3.8.4.
    - Update description of all packages.
    - Add missing python-ufc to Depends for binary package syfi-bin.
  * debian/watch:
    - Update download URL.
    - Update for DFSG mangle.
  * debian/copyright: Update Maintainer and Source fields.
  * debian/rules: Remove get-hg-source target.
  * debian/{python-syfi0.install,syfi-bin.install}: Allow both
    site-packages and dist-packages.
  * Bump dh compat level to 7.
  * Remove debian/patches/ginac-1.5.patch since GiNaC 1.5 is now supported.
  * Add debian/README.source.

 -- Johannes Ring <johannr@simula.no>  Mon, 15 Feb 2010 13:42:46 +0100

syfi (0.6.0.dfsg-1) unstable; urgency=low

  * Initial release (Closes: #528633)

 -- Johannes Ring <johannr@simula.no>  Wed, 15 Oct 2008 13:19:28 +0200
