=== debian/control ===
Source: syfi
Section: devel
Priority: extra
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Prud'homme <prudhomm@debian.org>, Johannes Ring <johannr@simula.no>
Build-Depends: cdbs (>= 0.4.90~),
 debhelper (>= 7),
 python-all-dev (>= 2.6.6-3~),
 cmake,
 swig,
 libginac-dev,
 pkg-config,
 python-numpy
Standards-Version: 3.9.2
X-Python-Version: >= 2.5
Homepage: http://www.fenicsproject.org
DM-Upload-Allowed: yes
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/syfi/trunk
Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/syfi/trunk

Package: libsyfi1.0-dev
Section: libdevel
Architecture: any
Depends: swig,
 ufc,
 python-numpy,
 libsyfi1.0 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Conflicts: libsyfi0-dev
Replaces: libsyfi0-dev
Provides: libsyfi0-dev
Suggests: python-swiginac (>= 1.5.1)
Description: Finite element method (FEM) C++ library - development files
 The finite element method (FEM) package SyFi is a C++ library built on top of
 the symbolic math library GiNaC. The name SyFi stands for Symbolic Finite
 Elements. The package provides polygonal domains, polynomial spaces, and
 degrees of freedom as symbolic expressions that are easily manipulated. This
 makes it easy to define finite elements and variational forms. These elements
 and forms are then used to generate efficient C++ code.
 .
 SyFi is similar to FFC in the sense that it has a compiler that generates UFC
 code based on variational forms and finite elements. It is also similar to
 FIAT in the sense that it implements many different finite elements.
 .
 This package contains the development files.

Package: syfi-dev
Section: libdevel
Architecture: all
Depends: libsyfi1.0-dev (>= ${source:Version}), ${misc:Depends}
Description: Empty package depending on latest SyFi development package
 The finite element method (FEM) package SyFi is a C++ library built on top of
 the symbolic math library GiNaC. The name SyFi stands for Symbolic Finite
 Elements. The package provides polygonal domains, polynomial spaces, and
 degrees of freedom as symbolic expressions that are easily manipulated. This
 makes it easy to define finite elements and variational forms. These elements
 and forms are then used to generate efficient C++ code.
 .
 SyFi is similar to FFC in the sense that it has a compiler that generates UFC
 code based on variational forms and finite elements. It is also similar to
 FIAT in the sense that it implements many different finite elements.
 .
 This package will always depend on the most recent version of libsyfiX-dev
 (X=version), so if you install it then you will get upgrades automatically.

Package: libsyfi1.0
Section: libs
Architecture: any
Conflicts: syfi
Replaces: syfi
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: syfi-doc, libsyfi1.0-dbg, python-syfi
Description: Finite element method (FEM) C++ library - shared libraries
 The finite element method (FEM) package SyFi is a C++ library built on top of
 the symbolic math library GiNaC. The name SyFi stands for Symbolic Finite
 Elements. The package provides polygonal domains, polynomial spaces, and
 degrees of freedom as symbolic expressions that are easily manipulated. This
 makes it easy to define finite elements and variational forms. These elements
 and forms are then used to generate efficient C++ code.
 .
 SyFi is similar to FFC in the sense that it has a compiler that generates UFC
 code based on variational forms and finite elements. It is also similar to
 FIAT in the sense that it implements many different finite elements.
 .
 This package contains the shared libraries.

Package: libsyfi1.0-dbg
Section: debug
Architecture: any
Depends: libsyfi1.0 (= ${binary:Version}), ${misc:Depends}
Conflicts: libsyfi0-dbg
Replaces: libsyfi0-dbg
Provides: libsyfi0-dbg
Description: Finite element method (FEM) C++ library - debugging libraries
 The finite element method (FEM) package SyFi is a C++ library built on top of
 the symbolic math library GiNaC. The name SyFi stands for Symbolic Finite
 Elements. The package provides polygonal domains, polynomial spaces, and
 degrees of freedom as symbolic expressions that are easily manipulated. This
 makes it easy to define finite elements and variational forms. These elements
 and forms are then used to generate efficient C++ code.
 .
 SyFi is similar to FFC in the sense that it has a compiler that generates UFC
 code based on variational forms and finite elements. It is also similar to
 FIAT in the sense that it implements many different finite elements.
 .
 This package contains the shared libraries with debugging symbols.

Package: python-syfi
Section: python
Architecture: any
Depends: python-numpy,
 python-swiginac,
 libsyfi1.0 (= ${binary:Version}),
 ${python:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: python-syfi0, ${python:Provides}
Suggests: syfi-doc
Conflicts: python-syfi0
Replaces: python-syfi0
Description: Finite element method (FEM) C++ library - Python bindings
 The finite element method (FEM) package SyFi is a C++ library built on top of
 the symbolic math library GiNaC. The name SyFi stands for Symbolic Finite
 Elements. The package provides polygonal domains, polynomial spaces, and
 degrees of freedom as symbolic expressions that are easily manipulated. This
 makes it easy to define finite elements and variational forms. These elements
 and forms are then used to generate efficient C++ code.
 .
 SyFi is similar to FFC in the sense that it has a compiler that generates UFC
 code based on variational forms and finite elements. It is also similar to
 FIAT in the sense that it implements many different finite elements.
 .
 This package contains the Python interface for SyFi.

Package: syfi-doc
Architecture: all
Section: doc
Depends: libsyfi1.0-dev (>= ${source:Version}),
 sfc (= ${source:Version}),
 ${misc:Depends}
Description: Finite element method (FEM) C++ library - documentation
 The finite element method (FEM) package SyFi is a C++ library built on top of
 the symbolic math library GiNaC. The name SyFi stands for Symbolic Finite
 Elements. The package provides polygonal domains, polynomial spaces, and
 degrees of freedom as symbolic expressions that are easily manipulated. This
 makes it easy to define finite elements and variational forms. These elements
 and forms are then used to generate efficient C++ code.
 .
 SyFi is similar to FFC in the sense that it has a compiler that generates UFC
 code based on variational forms and finite elements. It is also similar to
 FIAT in the sense that it implements many different finite elements.
 .
 This package contains documentation and demo programs for SyFi.

Package: sfc
Architecture: all
Depends: python-ufl,
 python-numpy,
 python-ufc,
 python-syfi (>= ${source:Version}),
 ${python:Depends},
 ${misc:Depends}
Conflicts: syfi-bin
Replaces: syfi-bin
Provides: syfi-bin
Description: SyFi Form Compiler
 The SyFi Form Compiler (SFC) is a form compiler from the FEniCS
 project, compiling variational forms from the Unified Form Language
 (UFL) to efficient C++ implementations of Unified Form-assembly Code
 (UFC). SFC uses symbolic expressions for finite elements from SyFi.
